/*
 * This file was generated automatically by xsubpp version 1.9508 from the
 * contents of Error.xs. Do not edit this file, edit Error.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Error.xs"
#define PERL_NO_GET_CONTEXT
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "RPM.h"

static CV* err_callback;

/*
  This was static, but it needs to be accessible from other modules, as well.
*/
SV* rpm_errSV;

/*
  This is a callback routine that the bootstrapper will register with the RPM
  lib so as to catch any errors. (I hope)
*/
static void rpm_catch_errors(void)
{
    /* Because rpmErrorSetCallback expects (void)fn(void), we have to declare
       our thread context here */
    dTHX;
    int error_code;
    const char* error_string;

    error_code = rpmErrorCode();
    error_string = rpmErrorString();

    /* Set the string part, first */
    sv_setpv(rpm_errSV, error_string);
    /* Set the IV part */
    sv_setiv(rpm_errSV, error_code);
    /* Doing that didn't erase the PV part, but it cleared the flag: */
    SvPOK_on(rpm_errSV);

    /* If there is a current callback, invoke it: */
    if (err_callback != Nullcv)
    {
        /* This is just standard boilerplate for calling perl from C */
        dSP;
        ENTER;
        SAVETMPS;
        PUSHMARK(sp);
        XPUSHs(sv_2mortal(newSViv(error_code)));
        XPUSHs(sv_2mortal(newSVpv((char*)error_string, strlen(error_string))));
        PUTBACK;

        /* The actual call */
        call_sv((SV *)err_callback, G_DISCARD);

        /* More boilerplate */
        SPAGAIN;
        PUTBACK;
        FREETMPS;
        LEAVE;
    }

    return;
}

static
SV* set_error_callback(pTHX_ SV* newcb)
{
    SV* oldcb;

    oldcb = (err_callback) ? newRV((SV *)err_callback) : newSVsv(&PL_sv_undef);

    if (SvROK(newcb)) newcb = SvRV(newcb);
    if (SvTYPE(newcb) == SVt_PVCV)
        err_callback = (CV *)newcb;
    else if (SvPOK(newcb))
    {
        STRLEN len;
        const char *name = SvPV(newcb, len);

        if (strstr(name, "::"))
            err_callback = get_cv(name, FALSE);
        else {
            SV *sv = sv_2mortal(newSVpvn("main::", 6));
            sv_catpvn(sv, name, len);
            err_callback = get_cv(SvPV_nolen(sv), FALSE);
        }
    }
    else
    {
        err_callback = Nullcv;
    }

    return oldcb;
}


#line 104 "Error.c"

XS(XS_RPM__Error_set_error_callback); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM__Error_set_error_callback)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: RPM::Error::set_error_callback(newcb)");
    {
	SV*	newcb = ST(0);
	SV *	RETVAL;
#line 102 "Error.xs"
    RETVAL = set_error_callback(aTHX_ newcb);
#line 117 "Error.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_RPM__Error_clear_errors); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM__Error_clear_errors)
{
    dXSARGS;
    if (items != 0)
	Perl_croak(aTHX_ "Usage: RPM::Error::clear_errors()");
    {
#line 110 "Error.xs"
/* This is just to offer an easy way to clear both sides of $RPM::err */
    sv_setpv(rpm_errSV, "");
    sv_setiv(rpm_errSV, 0);
    SvPOK_on(rpm_errSV);
#line 137 "Error.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_RPM__Error_rpm_error); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM__Error_rpm_error)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: RPM::Error::rpm_error(code, message)");
    {
	int	code = (int)SvIV(ST(0));
	char*	message = (char *)SvPV_nolen(ST(1));
#line 121 "Error.xs"
    rpmError(code, "%s", message);
#line 154 "Error.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_RPM__Error); /* prototype to pass -Wmissing-prototypes */
XS(boot_RPM__Error)
{
    dXSARGS;
    char* file = __FILE__;

    XS_VERSION_BOOTCHECK ;

        newXSproto("RPM::Error::set_error_callback", XS_RPM__Error_set_error_callback, file, "$");
        newXSproto("RPM::Error::clear_errors", XS_RPM__Error_clear_errors, file, "");
        newXSproto("RPM::Error::rpm_error", XS_RPM__Error_rpm_error, file, "$$");

    /* Initialisation Section */

#line 125 "Error.xs"
{
    rpm_errSV = get_sv("RPM::err", GV_ADD|GV_ADDMULTI);
    rpmErrorSetCallback(rpm_catch_errors);
    err_callback = Nullcv;
}

#line 183 "Error.c"

    /* End of Initialisation Section */

    XSRETURN_YES;
}

